<div class="bg-img">
  <div class="app-main-container">

    <mat-card>
      <mat-card-content>

        <div>
          <mat-error *ngIf="genresFormGroup.hasError('notValid')">
            The total genres percentage must be 100%.
          </mat-error>
        </div>

        <form [formGroup]="form" (ngSubmit)="onSubmit()">

          <mat-vertical-stepper formArrayName="formArray" [linear]="true" #stepper>

            <mat-step label="Fill out locations" state="locations" formGroupName="0"
              [stepControl]="formArray?.get([0])">
              <mat-form-field [hideRequiredMarker]="true" class="full-width-input">
                <mat-label>Origin Address</mat-label>
                <input matInput placeholder="City , Country" formControlName="originAddress" required>
                <mat-error>
                  The input must contain at least 5 symbols.
                </mat-error>
              </mat-form-field>

              <mat-form-field [hideRequiredMarker]="true" class="full-width-input">
                <mat-label>Destination Address</mat-label>
                <input matInput placeholder="City , Country" formControlName="destinationAddress" required>
                <mat-error>
                  The input must contain at least 5 symbols.
                </mat-error>
              </mat-form-field>

              <div>
                <button mat-button matStepperNext type="button">Next</button>
              </div>
            </mat-step>

            <mat-step label="Give a name" state="name" formGroupName="1" [stepControl]="formArray?.get([1])">

              <mat-form-field [hideRequiredMarker]="true" class="full-width-input">
                <mat-label>Name</mat-label>
                <input matInput placeholder="Name" formControlName="name" required>
                <mat-error>
                  The input must contain at least 3 symbols.
                </mat-error>
              </mat-form-field>

              <div>
                <button mat-button matStepperNext type="button">Next</button>
              </div>
            </mat-step>

            <mat-step label="Choose genres" state="genreChoice" formGroupName="2" [stepControl]="formArray?.get([2])">

              <div class="col-md-6">
                <div class="row genres-aligned">
                  <div class="col-md-12">

                    <mat-form-field [hideRequiredMarker]="true" class="full-width-input">
                      <mat-label>Genre 1</mat-label>
                      <mat-select formControlName="genreId1" name="Genre 1" aria-placeholder="Genre 1"
                        (selectionChange)="changed($event.value, 0)">
                        <mat-option value="" disabled>Choose a genre</mat-option>
                        <mat-option *ngFor="let genre of genres" [value]="genre.id">
                          {{ genre.name }}
                        </mat-option>
                      </mat-select>
                    </mat-form-field>

                  </div>

                  <div class="col-md-12">

                    <mat-form-field [hideRequiredMarker]="true" class="full-width-input">
                      <mat-label>Percentage 1</mat-label>
                      <input matInput type="number" placeholder="Percentage 1" formControlName="genrePercentage1"
                        (change)="check('genrePercentage1')" required>
                      <span matSuffix>%</span>
                      <mat-error>
                        The maximum value for this field is 100.
                      </mat-error>
                    </mat-form-field>

                  </div>
                </div>
              </div>

              <div class="col-md-6">
                <div class="row genres-aligned">
                  <div class="col-md-12">

                    <mat-form-field [hideRequiredMarker]="true" class="full-width-input"
                      *ngIf="genresFormGroup.get('genreId2')">
                      <mat-label>Genre 2</mat-label>
                      <mat-select formControlName="genreId2" name="Genre 2" aria-placeholder="Genre 2"
                        (selectionChange)="changed($event.value, 1)">
                        <mat-option value="" disabled>Choose a genre</mat-option>
                        <mat-option *ngFor="let allowedGenre of allowedGenres$ | async" [value]="allowedGenre.genre.id"
                          [disabled]="!allowedGenre.allowed">
                          {{ allowedGenre.genre.name }}
                        </mat-option>
                      </mat-select>
                    </mat-form-field>

                  </div>

                  <div class="col-md-12">

                    <mat-form-field [hideRequiredMarker]="true" class="full-width-input"
                      *ngIf="genresFormGroup.get('genrePercentage2')">
                      <mat-label>Percentage 2</mat-label>
                      <input matInput type="number" placeholder="Percentage 2" formControlName="genrePercentage2"
                        required (change)="check('genrePercentage2')">
                      <span matSuffix>%</span>
                      <mat-error>
                        The maximum value for this field is {{ maxPercentValues[1] }}.
                      </mat-error>
                    </mat-form-field>

                  </div>
                </div>
              </div>

              <div class="col-md-6">
                <div class="row genres-aligned">
                  <div class="col-md-12">

                    <mat-form-field [hideRequiredMarker]="true" class="full-width-input"
                      *ngIf="genresFormGroup.get('genreId3')">
                      <mat-label>Genre 3</mat-label>
                      <mat-select formControlName="genreId3" name="Genre 3" aria-placeholder="Genre 3"
                        (selectionChange)="changed($event.value, 2)">
                        <mat-option value="" disabled>Choose a genre</mat-option>
                        <mat-option *ngFor="let allowedGenre of allowedGenres$ | async" [value]="allowedGenre.genre.id"
                          [disabled]="!allowedGenre.allowed">
                          {{ allowedGenre.genre.name }}
                        </mat-option>
                      </mat-select>
                    </mat-form-field>

                  </div>

                  <div class="col-md-12">

                    <mat-form-field [hideRequiredMarker]="true" class="full-width-input"
                      *ngIf="genresFormGroup.get('genrePercentage3')">
                      <mat-label>Percentage 3</mat-label>
                      <input matInput type="number" placeholder="Percentage 3" formControlName="genrePercentage3"
                        required (change)="check('genrePercentage3')">
                      <span matSuffix>%</span>
                      <mat-error>
                        The maximum value for this field is {{ maxPercentValues[2] }}.
                      </mat-error>
                    </mat-form-field>

                  </div>
                </div>
              </div>

              <div class="col-md-6">
                <div class="row genres-aligned">
                  <div class="col-md-12">

                    <mat-form-field [hideRequiredMarker]="true" class="full-width-input"
                      *ngIf="genresFormGroup.get('genreId4')">
                      <mat-label>Genre 4</mat-label>
                      <mat-select formControlName="genreId4" name="Genre 4" aria-placeholder="Genre 4"
                        (selectionChange)="changed($event.value, 3)">
                        <mat-option value="" disabled>Choose a genre</mat-option>
                        <mat-option *ngFor="let allowedGenre of allowedGenres$ | async" [value]="allowedGenre.genre.id"
                          [disabled]="!allowedGenre.allowed">
                          {{ allowedGenre.genre.name }}
                        </mat-option>
                      </mat-select>
                    </mat-form-field>

                  </div>

                  <div class="col-md-12">

                    <mat-form-field [hideRequiredMarker]="true" class="full-width-input"
                      *ngIf="genresFormGroup.get('genrePercentage4')">
                      <mat-label>Percentage 4</mat-label>
                      <input matInput type="number" placeholder="Percentage 4" formControlName="genrePercentage4"
                        required>
                      <span matSuffix>%</span>
                      <mat-error>
                        The maximum value for this field is {{ maxPercentValues[3] }}.
                      </mat-error>
                    </mat-form-field>

                  </div>
                </div>
              </div>

              <div>
                <button mat-button matStepperNext type="button"
                  [disabled]="genresFormGroup.hasError('notValid')">Next</button>
              </div>
            </mat-step>

            <mat-step label="Give your preferance" state="preferences" formGroupName="2"
              [stepControl]="formArray?.get([2])">

              <div class="sliders">
                <mat-slide-toggle color="primary" [formControl]="useTopTracks">Use Top Tracks</mat-slide-toggle>

                <mat-slide-toggle color="primary" [formControl]="repeatSameArtist">Repeat Same Artist</mat-slide-toggle>

              </div>

              <div class="result-content">
                <mat-error class="internal-error" *ngIf="form.hasError('internalError')">
                  {{ formError }}
                </mat-error>

                <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
              </div>

              <button class="create-button" mat-raised-button>
                <mat-icon style="color: white;">headset</mat-icon>
                Generate Playlist
              </button>
              
            </mat-step>

            <!-- Icon overrides. -->
            <ng-template matStepperIcon="locations">
              <mat-icon>add_location</mat-icon>
            </ng-template>
            <ng-template matStepperIcon="name">
              <mat-icon>spellcheck</mat-icon>
            </ng-template>
            <ng-template matStepperIcon="genreChoice">
              <mat-icon>movie_filter</mat-icon>
            </ng-template>
            <ng-template matStepperIcon="preferences">
              <mat-icon>flare</mat-icon>
            </ng-template>

          </mat-vertical-stepper>
        </form>

      </mat-card-content>
    </mat-card>
  </div>
</div>